import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Turret here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Turret  extends Vehicle
{

    //the tank (vehicle) that this turret is attached to    
    private Vehicle parent;
    
    /**
     * constructor, init the turret with a parent.
     */
    public Turret(Vehicle parent)
    {
        this.parent = parent;
    }
    
    /**
     * Act - do whatever the Turret wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */    
    public void act() 
    {
        if (this.getX() != parent.getX() || this.getY() != parent.getY()) 
        {
            this.setLocation(parent.getX(),parent.getY());
        }
    }    
    
    /**
     * destroy this turret & remove the associated tank
     */
    public void destroy() 
    {
        try 
        {
            parent.destroy();  
        } catch (IllegalStateException e) 
        {
            System.out.println("Attempted to remove non existing tank parent");
        }
        super.destroy(); //remove me
    }    
}
