/**
 * Write a description of class trig here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public abstract class trig  
{
    /**
     * Calculates the angle from a co-ordinate location to another, using trig. 
     */
    
        public static int getFinalAngleFrom(int startX, int startY, int endX, int endY) {
 
            //get current angle to player
            int angleToPlayer = (int)trig.getAngleFrom(startX,startY,endX,endY);       
       
            /*
             * * The player is above the AI, inverse the turret angle (so it decreases
             * * */
             if (endY < startY) {                                         
                 if (endX < startX) {
                     angleToPlayer =   angleToPlayer;
                 } else {
                     angleToPlayer = 180 - angleToPlayer;
                 }           
             } else {
           /*
            * the player is below the AI, do not inverse angle
            */    
                if (endX > startX) {
                     angleToPlayer = 180 + angleToPlayer;
                } else {
                     angleToPlayer =  360 -  angleToPlayer;
                }     
       }
       //System.out.println("Final angle to player: "+angleToPlayer);
       return angleToPlayer;
    }

    
    private static final double getAngleFrom(int startX, int startY, int endX, int endY) {
    
        /*
         * For the purposes of this function we're drawing a right angle triangle (r.a.t),
         * and finding out the angles in it. One of them is 90 degrees - the one between
         * the opposite & the adjacent. 
         * 
         */
              
        //side A, opposite hyp. We square then squareroot so it is always
        //positive. Side A is the horizontal side of the r.a.t.
        double triSideOpp = Math.sqrt(Math.pow(endX - startX,2));
        //System.out.println("Side Opp: "+triSideOpp);
        
        //side B, adjacent hyp. The vertical side of the r.a.t.
        double triSideAdj = Math.sqrt(Math.pow(endY - startY,2));     
        //System.out.println("Side Adj: "+triSideAdj);
        
        //hypotenuse
        double triSideHyp = Math.sqrt((Math.pow(triSideOpp,2)) + (Math.pow(triSideAdj,2)));
        //System.out.println("Side H: "+triSideHyp);
        
        //the 90 degree angle in this r.angle triangle
        double triAngleOppAdj = 90;
        //System.out.println("Angle OppAdj: "+triAngleOppAdj);
        
        //asin = cos-1 (CAH)
        double triAngleAdjHyp = Math.toDegrees(Math.acos(triSideAdj/triSideHyp));
        //System.out.println("Angle AdjHyp: "+triAngleAdjHyp);
        
        //calculate the final angle with the rule that
        //the interior angles of a triangle add up to 180 degrees
        double triAngleOppHyp = (180-(triAngleOppAdj + triAngleAdjHyp));
        //System.out.println("Angle OppHyp: "+triAngleOppHyp);
        
        //finally return the angle
        return triAngleOppHyp;
    }
    
    public static final double distFrom(int startX, int startY, int endX, int endY) {
        //side A, opposite hyp. We square then squareroot so it is always
        //positive. Side A is the horizontal side of the r.a.t.
        double triSideOpp = Math.sqrt(Math.pow(endX - startX,2));
        //System.out.println("Side Opp: "+triSideOpp);
        
        //side B, adjacent hyp. The vertical side of the r.a.t.
        double triSideAdj = Math.sqrt(Math.pow(endY - startY,2));     
        //System.out.println("Side Adj: "+triSideAdj);
        
        //hypotenuse
        double triSideHyp = Math.sqrt((Math.pow(triSideOpp,2)) + (Math.pow(triSideAdj,2)));
        //System.out.println("Side H: "+triSideHyp);
        return triSideHyp;
    }
    public static int[] getOffsetFrom(int X, int Y, int Angle, double Amount) {
        int[] arrayToReturn = new int[2];
        double angle = Math.toRadians(Angle);
        arrayToReturn[0] = (int) (Math.round((double)X) - (double)Math.cos(angle) * (double)Amount);
        arrayToReturn[1] = (int) (Math.round((double)Y) - (double)Math.sin(angle) * (double)Amount);        
        return arrayToReturn;
    }

    
}

